<template>
  <v-container style="height: 100%">
    <v-row style="height: 100%">
      <v-col
        cols="12"
        sm="3"
      />

      <v-col
        cols="12"
        sm="6"
        class="d-flex"
      >
        <v-card
          class="mx-auto my-auto"
          outlined
          max-width="450"
        >
          <v-form
            class="py-10 px-5"
            @submit.prevent="handleLogin"
          >
            <v-list-item three-line>
              <v-list-item-content>
                <div class="d-flex justify-center">
                  <v-img
                    :src="require('@/assets/images/svg/login.svg')"
                    max-width="100"
                  />
                </div>

                <div class="overline text-center">
                  LNU
                </div>
                <v-list-item-title class="headline mb-2 text-center">
                  Sign in
                </v-list-item-title>
                <v-list-item-subtitle class="text-center">
                  to continue to <b>{{ $env.title }}</b>
                </v-list-item-subtitle>
              </v-list-item-content>
              <!--
              <v-list-item-avatar
                tile
                size="80"
              >

              </v-list-item-avatar> -->
            </v-list-item>

            <v-divider class="my-5" />

            <v-container>
              <v-row dense>
                <v-col cols="12">
                  <v-text-field
                    v-model="auth.username"
                    rounded
                    autocomplete="off"
                    outlined
                    label="Username"
                    required
                  />
                </v-col>

                <v-col cols="12">
                  <v-text-field
                    v-model="auth.password"
                    rounded
                    autocomplete="off"
                    type="password"
                    outlined
                    label="Password"
                    required
                  />
                </v-col>

                <v-col cols="12">
                  <v-btn
                    color="primary"
                    elevation="0"
                    type="submit"
                    block
                    rounded
                    x-large
                  >
                    Login
                  </v-btn>

                  <div class="d-flex justify-center mt-5">
                    No account yet?
                    <router-link
                      class="primary--text font-weight-bold ml-1"
                      :to="{ name: 'Register' }"
                    >
                      Register now!
                    </router-link>
                  </div>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card>
      </v-col>

      <v-col
        cols="12"
        sm="3"
      />
    </v-row>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState, mapMutations } from 'vuex'

import _get from 'lodash/get'

import axios from '@/config/axios'

export default {
  name: 'Login',

  data: () => ({
    auth: {
      username: undefined,
      password: undefined
    }
  }),

  computed: {
    ...mapState('user', {
      authUser: 'authUser'
    })
  },

  created () {
    window.localStorage.clear()

    this.setStateUser({
      state: 'authUser',
      value: null
    })
  },

  methods: {
    ...mapActions('auth', {
      getLoginToken: 'getLoginToken'
    }),

    ...mapActions('users', {
      getAuthUser: 'getAuthUser'
    }),

    ...mapMutations('users', {
      setStateUser: 'SET_STATE'
    }),

    async handleLogin (e) {
      try {
        const token = await this.getLoginToken({
          username: this.auth.username,
          password: this.auth.password
        })

        this.$localStorage.set('token', token)

        axios.defaults.headers.common.Authorization = `Bearer ${window.localStorage.token}`

        const data = await this.getAuthUser()

        return this.$router.push({ name: data.level === 'admin' ? 'Dashboard' : 'Archive' })
      } catch (error) {
        this.$localStorage.remove('token')
        const text = _get(error, 'response.data.message')
        this.$setAlert({ type: 'error', text })
      }
    }
  }
}
</script>
